﻿function GetPluginSettings()
{
    return {
        "name": "Telegram Channel",
        "id": "TelegramChannel",
        "version": "1.0.0",
        "description":	"TelegramChannel plugin",
        "author": "MilaDesign",
        "help url": "http://miladesign.ir/telegram-channel",
        "category": "MilaDesign Plugins",
		"dependency":	"",
        "type": "object",
        "rotatable": false,
        "flags": 0 | pf_singleglobal
    };
};

//////////////////////////////////////
// Conditions
AddStringParam("Channel Id", "Enter channel username without @");
AddCondition(0, cf_trigger, "On Get Details Success", "Channel", "On get {0} details success", "On get channel details success", "OnGetSuccess");
AddStringParam("Channel Id", "Enter channel username without @");
AddCondition(1, cf_trigger, "On Get Details Failed", "Channel", "On get {0} details failed", "On get channel details failed", "OnGetFailed");
AddStringParam("Channel Id", "Enter channel username without @");
AddCondition(2, cf_trigger, "On Get Not Channel", "Channel", "On {0} is not channel", "On channelId is not channel", "OnNotChannel");

//////////////////////////////////////
// Actions
AddStringParam("Channel Id", "Enter channel username without @");
AddAction(0, af_none, "Get Channel Details", "Channel", "Get {0} channel details", "Get channel details", "GetChannelDetails");

	
//////////////////////////////////////
// Expressions
AddExpression(0, ef_return_string, "Name", "Channel", "Name", "Channel Name");
AddExpression(1, ef_return_string, "Description", "Channel", "Description", "Channel Description");
AddExpression(2, ef_return_string, "Photo", "Channel", "Photo", "Channel Photo URL");
AddExpression(3, ef_return_string, "Members", "Channel", "Members", "Channel Members");

ACESDone();

//////////////////////////////////////
// Properties
var property_list = [
	new cr.Property(ept_text, "Telegram php address", "http://yoursite.com/telegram.php", "Enter your telegram.php address")
];

// Called by IDE when a new object type is to be created
function CreateIDEObjectType() {
    return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType() {
    assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance) {
    return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type) {
    assert2(this instanceof arguments.callee, "Constructor called as a function");

    // Save the constructor parameters
    this.instance = instance;
    this.type = type;

    // Set the default property values from the property table
    this.properties = {};

    for (var i = 0; i < property_list.length; i++)
        this.properties[property_list[i].name] = property_list[i].initial_value;

    // Plugin-specific variables
    // this.myValue = 0...
}

// Called when inserted via Insert Object Dialog for the first time
IDEInstance.prototype.OnInserted = function()
{
}

// Called when double clicked in layout
IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called after a property has been changed in the properties bar
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

// For rendered objects to load fonts or textures
IDEInstance.prototype.OnRendererInit = function(renderer)
{
}

// Called to draw self in the editor if a layout object
IDEInstance.prototype.Draw = function(renderer)
{
}

// For rendered objects to release fonts or textures
IDEInstance.prototype.OnRendererReleased = function(renderer)
{
}

