/******************************************/
/////	MilaDesign Plugins
/////	Name: Telegram Channel
/////	Version: 1.0.0
/////	Description: Telegram Channel plugin
/////	Email: Rezagah.Milad@Gmail.com
/////	Website: http://miladesign.ir/telegram-channel
/////	Telegram ID: https://telegram.me/MilaDesign
/******************************************/

// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

cr.plugins_.TelegramChannel = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{	
	var pluginProto = cr.plugins_.TelegramChannel.prototype;
		
/////////////////////////////////////
// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

// called on startup for each object type
	typeProto.onCreate = function()
	{
		if(this.runtime.isBlackberry10 || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81){
			var scripts=document.getElementsByTagName("script");
			var scriptExist=false;
			for(var i=0;i<scripts.length;i++){
				if(scripts[i].src.indexOf("cordova.js")!=-1||scripts[i].src.indexOf("phonegap.js")!=-1){
					scriptExist=true;
					break;
				}
			}
			if(!scriptExist){
				var newScriptTag=document.createElement("script");
				newScriptTag.setAttribute("type","text/javascript");
				newScriptTag.setAttribute("src", "cordova.js");
				document.getElementsByTagName("head")[0].appendChild(newScriptTag);
			}
		}
	};

/////////////////////////////////////
// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
// called whenever an instance is created
	instanceProto.onCreate = function() {
		
		this.url = this.properties[0]
		
	    this.response = {};
	    this.data = {};
        
	    this.channelInfo;
	    this.channelId;
		
	    var self = this;
		
	};
	
	instanceProto.draw = function(ctx) {};
	instanceProto.drawGL = function (glw) {};

//////////////////////////////////////
// Conditions
	function Cnds() {};

	Cnds.prototype.OnGetSuccess = function (channelId) {
	    return channelId === this.channelId;
	};

	Cnds.prototype.OnNotChannel = function (channelId) {
	    return channelId === this.channelId;
	};

	Cnds.prototype.OnGetFailed = function (channelId) {
	    return channelId === this.channelId;
	};
	
	
	pluginProto.cnds = new Cnds();
	
//////////////////////////////////////
// Actions
	function Acts() {};
	
	Acts.prototype.GetChannelDetails = function (channelId) {
	    var self = this;
	    var http = new XMLHttpRequest();

	    http.onloadend = function () {
	        if (http.status != 0 && http.responseText) {
				self.channelId = channelId;
	            try {
	                self.response = JSON.parse(http.responseText);
					switch(self.response['is_channel']) {
						case true:
							self.channelInfo = http.responseText;
							self.runtime.trigger(cr.plugins_.TelegramChannel.prototype.cnds.OnGetSuccess, self);
							break;
						case false:
							self.runtime.trigger(cr.plugins_.TelegramChannel.prototype.cnds.OnNotChannel, self);
							break;
						default:
							self.runtime.trigger(cr.plugins_.TelegramChannel.prototype.cnds.OnNotChannel, self);
					}
	            } catch (e) {
					console.log(e.message);
	                self.runtime.trigger(cr.plugins_.TelegramChannel.prototype.cnds.OnGetFailed, self);
	            }
	        }
	    };
	    http.open("GET", self.url + "?id=" + channelId);
	    http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	    http.send();
	};

	pluginProto.acts = new Acts();
	
//////////////////////////////////////
// Expressions
	function Exps() {};
	
	Exps.prototype.Name = function (ret) {
		this.data = JSON.parse(this.channelInfo);
		ret.set_string(this.data['title']);
	};
	
	Exps.prototype.Description = function (ret) {
		this.data = JSON.parse(this.channelInfo);
		ret.set_string(this.data['description']);
	};
	
	Exps.prototype.Photo = function (ret) {
		this.data = JSON.parse(this.channelInfo);
		ret.set_string(this.data['photo']);
	};
	
	Exps.prototype.Members = function (ret) {
		this.data = JSON.parse(this.channelInfo);
		ret.set_string(this.data['members']);
	};
	
	pluginProto.exps = new Exps();

}());